
#define MIN_STOPLOSS_POINT 10
#define MIN_TAKEPROFIT_POINT 10 
#define MAGIC 0

extern double dLots = 0.10;

extern string periodBegin    = "00:00"; //The period of high/low
extern string periodEnd      = "10:00"; //The period of high/low

extern int        TimeZone         =       0; // Difference between server time and local time   
extern string     TimeTrade1        = "09:00"; // Local time of opening orders 
extern string     TimeFinish1       = "23:00"; // Local time of closing pending orders

extern int     PeriodWATR=10;
extern double  Kwatr=1.0000;

extern bool UseTimelimit=false;
extern int MinutesBetweenOrders = 15;
extern double MaximumRisk = 1;
extern string sNameExpert = "SIM-X System";
extern int nAccount =0;

extern double dBuyStopLossPoint = 0;
extern double dSellStopLossPoint = 0;
extern double dBuyTakeProfitPoint = 0;
extern double dSellTakeProfitPoint = 0;
extern double dBuyTrailingStopPoint = 10;
extern double dSellTrailingStopPoint = 10;
extern int nSlippage = 1;
extern bool lFlagUseHourTrade = True;
extern bool lFlagUseSound = false;
extern string sSoundFileName = "alert.wav";
extern color colorOpenBuy = Blue;
extern color colorCloseBuy = Aqua;
extern color colorOpenSell = Red;
extern color colorCloseSell = Aqua;

void deinit() {
   Comment("");
}
int Crossed (double line1 , double line2)
   {
      static int last_direction = 0;
      static int current_direction = 0;
      
      //Don't work in the first load, wait for the first cross!
      static bool first_time = true;
      if(first_time == true)
      {
         first_time = false;
         return (0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down

      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   
   datetime OpenTime1 = StrToTime(TimeTrade1) + TimeZone*3600;
   datetime CloseTime1 = StrToTime(TimeFinish1) + TimeZone*3600;
   
   if (FoundRecentOpenedOrder(1440) == TRUE) {
    return(0);
    }
   dLots=NormalizeDouble(AccountFreeMargin()*MaximumRisk/50000,1);
   
   
   //----- Box Range
   datetime dtTradeDate=TimeCurrent();
   datetime dtTimeBegin, dtTimeEnd;
   double   dPriceHigh,  dPriceLow, sarCurrent, sarPrevious;
   int      iBarBegin,   iBarEnd;

  dtTimeBegin = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + periodBegin);
  dtTimeEnd = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + periodEnd);
      
  iBarBegin = iBarShift(NULL, 0, dtTimeBegin);
  iBarEnd = iBarShift(NULL, 0, dtTimeEnd);
  dPriceHigh = High[Highest(NULL, 0, MODE_HIGH, iBarBegin-iBarEnd, iBarEnd)];
  dPriceLow = Low [Lowest (NULL, 0, MODE_LOW , iBarBegin-iBarEnd, iBarEnd)];
  
  //double Fish = iCustom(NULL, 0, "Fisher_m11",RangePeriods,PriceSmoothing, IndexSmoothing,0,0);    
  
  double LineMin = iCustom(NULL, 0, "Hist_StepMA_Stoch_KV1_Ex_03",PeriodWATR,Kwatr,0,0);
  double LineMid = iCustom(NULL, 0, "Hist_StepMA_Stoch_KV1_Ex_03",PeriodWATR,Kwatr,1,0);
   
   int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
	double HiPrice		= iHigh(NULL,PERIOD_D1,shift);
	double LoPrice		= iLow (NULL,PERIOD_D1,shift);
	   
   //----- EMA Cross
   static int isCrossed  = 0;
   isCrossed = Crossed (LoPrice,HiPrice);
   
   //-------------//         
   bool lFlagBuyOpen = false, lFlagSellOpen = false, lFlagBuyClose = false, lFlagSellClose = false;
   
   lFlagBuyOpen = (
                   LineMid > 0
                   && Bid == dPriceHigh
                   && (TimeCurrent() >= OpenTime1 && TimeCurrent() <= CloseTime1)
                   || LineMid > 0 && Bid > HiPrice
                   );
   lFlagSellOpen = (
                   LineMin < 0
                   && Ask == dPriceLow
                   && (TimeCurrent() >= OpenTime1 && TimeCurrent() <= CloseTime1)
                   || LineMin < 0 && Ask < LoPrice
                   );
                    
   lFlagBuyClose =  (
                     LineMin < 0
                     ); 
   lFlagSellClose = (
                     LineMid > 0
                     );
   
  static datetime lastordertime= 0;                                      // ***Lowphat Addition***
  int sometimelimit = MinutesBetweenOrders * 60;                         // ***Lowphat Addition***
  
  int allorder = OrdersTotal();
   if (!ExistPositions() && allorder<1 && UseTimelimit==true){

      if (lFlagBuyOpen && CurTime()-lastordertime > sometimelimit){     // ***Lowphat Addition*** 
         OpenBuy();
         lastordertime= TimeCurrent();                                      // ***Lowphat Addition***
         return(0);
      }

      if (lFlagSellOpen && CurTime()-lastordertime > sometimelimit){    // ***Lowphat Addition***
         OpenSell();
         lastordertime= TimeCurrent();                                      // ***Lowphat Addition***
         return(0);
      }}
         if (!ExistPositions() && UseTimelimit==false){                 // ***Lowphat Addition***

      if (lFlagBuyOpen && allorder<1){
         OpenBuy();
         return(0);
      }

      if (lFlagSellOpen && allorder<1){
         OpenSell();
          return(0);
   }}

   if (ExistPositions()){
      if(OrderType()==OP_BUY){
         if (lFlagBuyClose){
            bool flagCloseBuy = OrderClose(OrderTicket(), OrderLots(), Bid, nSlippage, colorCloseBuy); 
            if (flagCloseBuy && lFlagUseSound) 
               PlaySound(sSoundFileName); 
            return(0);
         }
      }
      if(OrderType()==OP_SELL){
         if (lFlagSellClose){
            bool flagCloseSell = OrderClose(OrderTicket(), OrderLots(), Ask, nSlippage, colorCloseSell); 
            if (flagCloseSell && lFlagUseSound) 
               PlaySound(sSoundFileName); 
            return(0);
         }
      }
   }
   
   if (dBuyTrailingStopPoint > 0 || dSellTrailingStopPoint > 0){
      
      for (int i=0; i<OrdersTotal(); i++) { 
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
            bool lMagic = true;
            if (MAGIC > 0 && OrderMagicNumber() != MAGIC)
               lMagic = false;
            
            if (OrderSymbol()==Symbol() && lMagic) { 
               if (OrderType()==OP_BUY && dBuyTrailingStopPoint > 0) { 
                  if (Bid-OrderOpenPrice() > dBuyTrailingStopPoint*Point) { 
                     if (OrderStopLoss()<Bid-dBuyTrailingStopPoint*Point) 
                        ModifyStopLoss(Bid-dBuyTrailingStopPoint*Point); 
                  } 
               } 
               if (OrderType()==OP_SELL) { 
                  if (OrderOpenPrice()-Ask>dSellTrailingStopPoint*Point) { 
                     if (OrderStopLoss()>Ask+dSellTrailingStopPoint*Point || OrderStopLoss()==0)  
                        ModifyStopLoss(Ask+dSellTrailingStopPoint*Point); 
                  } 
               } 
            } 
         } 
      } 
   }
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         bool lMagic = true;
         
         if (MAGIC > 0 && OrderMagicNumber() != MAGIC)
            lMagic = false;

			if (OrderSymbol()==Symbol() && lMagic) {
				return(True);
			}
		} 
	} 
	return(false);
}

void ModifyStopLoss(double ldStopLoss) { 
   bool lFlagModify = OrderModify(OrderTicket(), OrderOpenPrice(), ldStopLoss, OrderTakeProfit(), 0, CLR_NONE); 
   if (lFlagModify && lFlagUseSound) 
      PlaySound(sSoundFileName); 
} 

void OpenBuy() { 
   double dStopLoss = 0, dTakeProfit = 0;

   if (dBuyStopLossPoint > 0)
      dStopLoss = Bid-dBuyStopLossPoint*Point;
   
   if (dBuyTakeProfitPoint > 0)
     dTakeProfit = Ask + dBuyTakeProfitPoint * Point; 
 
   
   int numorder = OrderSend(Symbol(), OP_BUY, 1, Ask, nSlippage, dStopLoss, dTakeProfit, sNameExpert, MAGIC, 0, colorOpenBuy); 
   
   if (numorder > -1 && lFlagUseSound) 
      PlaySound(sSoundFileName);
} 

void OpenSell() { 
   double dStopLoss = 0, dTakeProfit = 0;
   
   if (dSellStopLossPoint > 0)
      dStopLoss = Ask+dSellStopLossPoint*Point;
   
   if (dSellTakeProfitPoint > 0)
      dTakeProfit = Bid-dSellTakeProfitPoint*Point;
   
   int numorder = OrderSend(Symbol(),OP_SELL, 1, Bid, nSlippage, dStopLoss, dTakeProfit, sNameExpert, MAGIC, 0, colorOpenSell); 
   
   if (numorder > -1 && lFlagUseSound) 
      PlaySound(sSoundFileName); 
} 

//+------------------------------------------------------------------+

int TotalHistoryOrders() {
   int cnt = 0;
   int TotalOpenOrders = 0;
   cnt=OrdersHistoryTotal();
   if(cnt==0) {
      return(0);
   }
   else {
      for(;cnt>=0;cnt--) {
         RefreshRates();
         OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY);
         if(OrderSymbol()==Symbol()) {
            TotalOpenOrders++;
         }
      }
   }
   return(TotalOpenOrders);
}

int FoundRecentOpenedOrder(int TF) {
   int last_order_idx = (TotalHistoryOrders() - 300);
   OrderSelect(last_order_idx,SELECT_BY_POS,MODE_HISTORY);
   if (OrderCloseTime() >= iTime(Symbol(), TF, 0)) {
   //if (OrderCloseTime() >= TimeCurrent()) {
      return(TRUE);
   }
   return(FALSE);
}